unit nes_ppu;

interface
  uses windows,sysutils,nes;

    procedure RefreshScreen (Y1, Y2 : integer);
    procedure RefreshBackGround(Y1, Y2 : integer);
    procedure RefreshSprite(Y1, Y2 : integer);

type
  TSPR = record
 y, no, atr, x : byte;
  end;

  var
  _i:integer = 0;
  PP:array[0..240]of Pbytearray;
  _spal:boolean = false;
  xbuf:Pbytearray;
    sprite : ^TSPR;
   n:integer;
     is_back:boolean = false;
implementation
uses main;


function ScreenON:integer;
begin
result := (PPU[1] and $08);
end;

function BGAdrHI:integer;
begin
result := (PPU[0]and $10);
end;

function VRAMADR(V:integer):pointer;
begin
result :=  @VPage[(V) shr 10][(V)];
end;

function PAL(c,cc:integer):integer;
begin
result := ((c)+cc);
end;



procedure RefreshBackGround(Y1,Y2:integer);
var
  vadr:integer;
  iPP,
  Line : integer;
  cc, c1, c2 : byte;
  line1:integer;
  P: Pbytearray;
  nametbl,
  x, y, X1, vofs,h , ntbl : integer;
  no, atr:byte;
  i ,ii,_h: integer;

begin
 i := 0;
  if (PPU[1] and $8)=0 then
  begin
    for _h := Y1 to Y2 do
    begin
     line := _h;
     //PP := BackBuffer.ScanLines[line];
      FillChar(PP[line]^,BackBuffer.Width, BLACK_COLOR);
    end;
  end
  else
  begin

asm mov	vofs,0 end;
if (PPU[0] and $10)<>0 then begin asm mov vofs,$1000 end; end;
y := Y1 + ScrollY;

asm
push	edi
mov		edi, y
and		edi, 7
mov		h, 8
sub		h, edi
add		vofs, edi
shr		y,3
pop		edi
end;

//PP[y][y] := PP[y][y] - ScrollX and 7;

ntbl := ($2000 + (PPU[0]and $3) shl 10);// * $400;
    asm
    push edi
    mov edi,Y1
    mov Line ,edi
    mov iPP ,0
    end;
repeat
x := (ScrollX  shr 3);


    if (y>=30) then
    begin
    asm sub y, 30 end;
    asm xor ntbl, $800 end;
  //      dec(y, 30);
  //      ntbl := ntbl xor $800;
    end;

    asm
    push  edi
    mov edi,ntbl
    mov nametbl ,edi end;
//    nametbl := ntbl;

    for X1 := 0 to 32 do
    begin
    no := VRAM[nametbl + x + y * 32];
    atr := VRAM[nametbl + $03C0 + ( x shr 2 ) + ( y shr 2 ) * 8];
    cc := ((atr shr ((x and 2) + (y and 2) * 2)) and 3) * 4;
    vadr := no * 16 + vofs;
    for i:= 0 to (h-1)  do
    begin
   // P := PP[Line+i];//BackBuffer.scanlines[Line + i];
    c1 := ((Ord(VPage[vadr shr 10][vadr]) shr 1) and $55) or (Ord(VPage[(vadr + 8) shr 10][vadr + 8]) and $AA);
    c2 := (Ord(VPage[vadr shr 10][vadr]) and $55) or ((Ord(VPage[(vadr + 8) shr 10][vadr + 8]) shl 1) and $AA);
    PP[Line + i][ipp]   := VRAM[$3F00+ ((c1 shr 6) and 3) + cc];
    PP[Line + i][ipp+1] := VRAM[$3F00+ ((c2 shr 6) and 3) + cc];
    PP[Line + i][ipp+2] := VRAM[$3F00+ ((c1 shr 4) and 3) + cc];
    PP[Line + i][ipp+3] := VRAM[$3F00+ ((c2 shr 4) and 3) + cc];
    PP[Line + i][ipp+4] := VRAM[$3F00+ ((c1 shr 2) and 3) + cc];
    PP[Line + i][ipp+5] := VRAM[$3F00+ ((c2 shr 2) and 3) + cc];
    PP[Line + i][ipp+6] := VRAM[$3F00+ (c1 and 3) + cc];
    PP[Line + i][ipp+7] := VRAM[$3F00+ (c2 and 3) + cc];

    asm inc vadr end;
    end;


    asm inc x end;
    if x>=32 then
    begin
    asm  mov x, 0 end;//asm
    asm
    push edi
    mov edi,ntbl
    xor edi,$400
    mov nametbl,edi end;
//      nametbl := ntbl xor $400;
    end;




    asm add iPP, 8 end; //asm
    end;


     asm
     push edi
     mov edi,line
     add edi,h
     mov line,edi
     mov iPP , 0
     push edi
     push edx
     push eax
     mov edx,7
     not edx
     mov edi,vofs
     and edi,edx
     mov vofs,edi

     //vofs := vofs and not(7);

     push edi
     mov edi,Y2
     sub edi,line
     mov h,edi
     end;
//     h := Y2 - Line;

     if (h>8) then
     asm mov h,8 end;
     asm inc y end; //asm

     until (line >= Y2);
    end;

//    setwindowtext(main_hwnd,pchar(inttostr(((c2 shr 2) and 3) + cc)));
end;


procedure RefreshScreen(Y1, Y2 : integer);
var
PP:Pbytearray;
i:integer;
begin
   asm inc Y2   end;

     if showbg then
    begin
    RefreshBackGround(Y1,Y2);
    end
    else
    begin
    for i := Y1 to Y2 do
    begin
    PP := BackBuffer.ScanLines[i];
    FillChar(PP^, BackBuffer.Width, BLACK_COLOR);
    end;
     end;


     if showsp = true then
     begin
     if (PPU[1] and $10)<>0 then
     RefreshSprite(Y1,Y2)
     end;

end;


procedure RefreshSprite(Y1, Y2 : integer);
var
  n, vofs : integer;
  HH : byte;
  iPP, C : integer;
  P:Pbytearray;
  x, y, no, atr, CC, J, c1, c2 : integer;
  h, t, incr, vadr : integer;

begin
  asm mov vofs ,0 end;
  if (PPU[0] and $20)<>0 then { Sprite 16 }
    asm mov HH , 16 end
  else
  begin
   asm mov HH , 8 end;
    if (PPU[0] and $08)<>0 then { Sprite patterm address }
   asm mov vofs,$1000 end;
   end;
  asm mov n , $00FC end;
//   n := $00FC;
   repeat
   sprite := @SRAM[n];
  
   y := sprite.y;
    if not((y>Y2) or (y<(Y1-HH))) then
    begin
      x   := sprite.x;
      no  := sprite.no;
      atr := sprite.atr;
      cc  := (atr and $3) * 4 + 16;
      if (PPU[0] and $20)<>0 then { Sprite 16 }
        vadr := ((no and $1) shl 12) + (no shr 1)* 32
      else
   vadr := no * 16 + vofs;
     // C := vadr;
      asm
      push edi
      mov edi,vadr
      mov C,edi
      end;
     // iPP := x;
      asm
      push edi
      mov edi,x
      mov ipp,edi
      end;
      asm mov incr , 1 end;
      //incr := 1;
      if (atr and V_FLIP)<>0 then
      begin

        asm mov incr, -1 end;
      //  incr := -1;
        asm
        add C, 7;
        end;
      //  inc(C,7);

        if (PPU[0] and $20)<>0 then { Sprite 16 }
          inc(C, 16);
      end;
//t := Y1 - y;
      asm
      push edi
      mov edi,Y1
      sub edi,y
      mov t,edi
      end;

      if t>0 then
      begin
        inc(C, t*incr);
      //iPP := x;
      asm
      push edi
      mov edi,x
      mov ipp,edi
      end;
        if (t>8) then
          inc(C, incr*8);
      end
      else
      asm mov t, 0 end;
     // t := 0;
//      h := Y2 - y + 1;
      asm
      push edi
      push edx
      mov edi,Y2
      mov edx,y
      sub edi,edx
      inc edi
      mov h,edi
      end;

      if (h>HH) then h := HH;
      repeat
      //P := PP[y+t];//BackBuffer.ScanLines[y+t];
       if (t=8) then  inc(C, incr*8);

        c1 := ((Ord(VPage[C shr 10][C]) shr 1) and $55) or (Ord(VPage[(C + 8) shr 10][C + 8]) and $AA);
        c2 := (Ord(VPage[C shr 10][C]) and $55) or ((Ord(VPage[(C + 8) shr 10][C + 8]) shl 1) and $AA);
        J := Ord(VPage[C shr 10][C]) or Ord(VPage[(C + 8) shr 10][C + 8]);

        if J<>0 then
        if (atr and H_FLIP)<>0 then
        begin

if (J and $80)<>0 then PP[y+t][iPP + 7] := VRAM[$3F00 + ((c1 shr 6) and 3) + cc];
if (J and $40)<>0 then PP[y+t][iPP + 6] := VRAM[$3F00 + ((c2 shr 6) and 3) + cc];
if (J and $20)<>0 then PP[y+t][iPP + 5] := VRAM[$3F00 + ((c1 shr 4) and 3) + cc];
if (J and $10)<>0 then PP[y+t][iPP + 4] := VRAM[$3F00 + ((c2 shr 4) and 3) + cc];
if (J  and $8)<>0 then PP[y+t][iPP + 3] := VRAM[$3F00 + ((c1 shr 2) and 3) + cc];
if (J  and $4)<>0 then PP[y+t][iPP + 2] := VRAM[$3F00 + ((c2 shr 2) and 3) + cc];
if (J  and $2)<>0 then PP[y+t][iPP + 1] := VRAM[$3F00 + (c1 and 3) + cc];
if (J  and $1)<>0 then PP[y+t][iPP + 0] := VRAM[$3F00 + (c2 and 3) + cc];
        end
        else
        begin
if (J and $80)<>0 then PP[y+t][iPP + 0] := VRAM[$3F00 + ((c1 shr 6) and 3) + cc];
if (J and $40)<>0 then PP[y+t][iPP + 1] := VRAM[$3F00 + ((c2 shr 6) and 3) + cc];
if (J and $20)<>0 then PP[y+t][iPP + 2] := VRAM[$3F00 + ((c1 shr 4) and 3) + cc];
if (J and $10)<>0 then PP[y+t][iPP + 3] := VRAM[$3F00 + ((c2 shr 4) and 3) + cc];
if (J and $8)<>0 then PP[y+t][iPP + 4] := VRAM[$3F00 + ((c1 shr 2) and 3) + cc];
if (J and $4)<>0 then PP[y+t][iPP + 5] := VRAM[$3F00 + ((c2 shr 2) and 3) + cc];
if (J and $2)<>0 then PP[y+t][iPP + 6] := VRAM[$3F00 + (c1 and 3) + cc];
if (J and $1)<>0 then PP[y+t][iPP + 7] := VRAM[$3F00 + (c2 and 3) + cc];
        end;
        asm inc t end;
        inc(C, incr);
        until t>=h;
        end;
        dec(n, $04);
        until n<$0000;

end;

end.
